package com.sams.ant.taskdef;

import org.apache.tools.ant.Task;
import org.apache.tools.ant.BuildException;
import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.types.FileSet;

import java.util.HashSet;
import java.util.ArrayList;
import java.util.Iterator;

/*
 * Class: com.sams.ant.task.ClassToSource
 *
 * @author Kirk Pepperdine
 */

public class ClassToSource extends Task {

    private FileSet sourcepath;
    private FileSet classpath;
    private boolean failonerror = true;

    public ClassToSource() {}

    public void setFailonerror(boolean value) { failonerror=value; }

    public FileSet createClassPath() {
        this.classpath = new FileSet();
        return classpath;
    }

    public FileSet createSourcePath() {
        this.sourcepath = new FileSet();
        return this.sourcepath;
    }

    public void execute() throws BuildException {
        log("Reconciling class and source files");
        try {
            execute0();
        } catch (BuildException be) {
            if (failonerror)
                throw be;
            else
                log(be.getMessage());
        }
        log("Reconciliation completed");
    }

    public void execute0() throws BuildException {
        HashSet classFiles = this.classFiles();
        Iterator iterator = this.sourceFiles().iterator();
        while (iterator.hasNext())
            classFiles.remove(iterator.next());

        if ( ! classFiles.isEmpty()) {
            Iterator i = classFiles.iterator();
            while (i.hasNext())
                log("No source found for " + (String)i.next());
            // throw new BuildException("Source cannot be found for all classes");
            throw new BuildException("classpath contains artifacts not found in sourcepath");
        }
    }

    private HashSet classFiles() {
        String[] filelist = this.classpath.getDirectoryScanner(super.getProject()).getIncludedFiles();
        HashSet set = new HashSet();

        String className;
        for (int i = 0; i < filelist.length; i++) {
            if ( filelist[i].endsWith(".class"))
                if (filelist[i].indexOf('$') < 0) {
                    className = filelist[i].substring( 0, filelist[i].length() - 6);
                    set.add(className);
                }
        }

        return set;

    }

    private ArrayList sourceFiles() {
        String[] filelist = this.sourcepath.getDirectoryScanner(super.getProject()).getIncludedFiles();
        ArrayList list = new ArrayList();
        String className;
        for (int i = 0; i < filelist.length; i++) {
            if ( filelist[i].endsWith(".java")) {
                list.add(filelist[i].substring( 0, filelist[i].length() - 5));
            }
        }
        return list;
    }
}
