package com.sams.ant.listeners;

import org.apache.tools.ant.BuildEvent;
import org.apache.tools.ant.BuildListener;
import org.apache.tools.ant.Project;

public class ExecListener implements BuildListener  {

    public final static String EXECLISTENER_PROPERTY_NAME =
            "execlistener.executable";

    private Throwable throwable;
    public ExecListener() {}

    public void buildStarted(BuildEvent event) {}

    public void buildFinished(BuildEvent event) {

        String command = event.getProject().getProperty(
                EXECLISTENER_PROPERTY_NAME);
        if ( command == null) {
            event.getProject().log( "Exception: no command specified.",
                                    Project.MSG_WARN);
            return;
        }

        try {
            Runtime runtime = Runtime.getRuntime();
            Process process = runtime.exec( command);
            process.waitFor();
        } catch(Exception e) {
            event.getProject().log( "Exception " +
                                    e.getClass().toString() +
                                    " : " + e.getMessage(),
                                    Project.MSG_WARN);
        }
    }

    public void targetStarted(BuildEvent event) {}
    public void targetFinished(BuildEvent event) {}
    public void taskStarted(BuildEvent event) {}
    public void taskFinished(BuildEvent event) {}
    public void messageLogged(BuildEvent event) {}
}
