/**
  * 
  * Custom DataType
  *
  * Sorts out the files for the specified type
  * in a directory. To be used in conjunction
  * with <code>com.sams.ant.typedef.DirectorySet.
  * In carrying out it's task, it makes use of
  * a DirectoryScanner.
  *
  * @author Kirk Pepperdine
  *
  * @see com.sams.ant.typedef.Directory
  * @see org.apache.tools.ant.DirectoryScanner
  *
  */
package com.sams.ant.typedef;

import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.types.DataType;

public class Directory extends DataType {

    private String dir;
    private String[] dirList;
    private String type;

    public Directory() {
        super();
    }

    public void setType(String type) {
        this.type = type;
    }

    public void setName(String directory) {
        this.dir = directory;
    }

    private String[] fileList() {
        DirectoryScanner scanner = new DirectoryScanner();
        scanner.setBasedir(this.dir);
        String[] args = {"**/*"};
        if (type != null)
            args[0] = args[0].concat("." + type);

        scanner.setIncludes(args);
        scanner.scan();
        return scanner.getIncludedFiles();
    }

    public String[] getFileList() {
        if (dirList == null)
            dirList = fileList();
        return fileList();
    }
}
