/**
  * 
  * Custom DataType
  *
  * Represents a set of directories. This custom
  * DataType is primary used by ClassToSource. It
  * employees a Directory to fetter out either the
  * class or source files found in the set of
  * directories passed to it.
  *
  * @author Kirk Pepperdine
  *
  * @see com.sams.ant.typedef.DirectorySet
  *
  *
  * @author Kirk Pepperdine
  */
package com.sams.ant.typedef;

import org.apache.tools.ant.DirectoryScanner;
import org.apache.tools.ant.types.DataType;

import java.util.Iterator;
import java.util.HashSet;

public class DirectorySet extends DataType {

    public final static String CLASS = "class";
    public final static String SOURCE = "java";

    private String type;
    private HashSet set;

    public DirectorySet() {
        super();
        set = new HashSet();
    }

    public void setType(String type) {
        this.type = type;
    }

    public Directory createDir() {
        Directory dir = new Directory();
        dir.setType(this.type);
        set.add(dir);
        return dir;
    }

    public String[] getFileList() {
        HashSet allFiles = new HashSet();
        Iterator iter = set.iterator();
        while (iter.hasNext()) {
            Directory dir = (Directory)iter.next();
            String[] files = dir.getFileList();
            for ( int i = 0; i < files.length; i++)
                allFiles.add(files[i]);
        }

        String[] list = new String[1];
        list = (String[])allFiles.toArray(list);

        return list;
    }
}
