/*
 * ReadChannel
 *
 * @author kpepperdine
 * Date: May 30, 2002
 * Time: 10:58:08 AM
 */

package com.sams.ant.channel;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.ObjectMessage;
import javax.jms.TopicSubscriber;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class ReadChannel extends Channel implements MessageListener {

    private ChannelListener listener;
    private TopicSubscriber subscriber;
    private ChannelException channelException;

    public ReadChannel() {}

    public ChannelException getChannelException () {
        return channelException;
    }

    /**
     * IOException, NamingException, JMSException
     */
    public void open(String host, String port, String userid, String password, String topicName) throws ChannelException {
        try {
            super.open(host,port,userid,password,topicName);
            this.subscriber = super.getSession().createSubscriber(super.getTopic());
            this.subscriber.setMessageListener(this);
            super.getConnection().start();
        } catch (Exception e) {
            throw new ChannelException(e);
        }
    }

    public void close() {
        try {
            this.subscriber.setMessageListener(null);
            this.unregisterConnectionListener(this.listener);
            super.close();
        } catch (JMSException e) {
        }
    }

    public void onMessage(Message jmsMessage) {
        this.channelException = null;
        try {
            Content packet = (Content)((ObjectMessage)jmsMessage).getObject();
            this.send(packet);
        } catch (Throwable throwable) {
            this.channelException = new ChannelException(throwable);
        }
    }

    public void registerConnectionListener(ChannelListener listener) {
        this.listener = listener;
    }

    public void unregisterConnectionListener(ChannelListener listener) {
        if (this.listener == listener)
            this.listener = null;
    }

    private void send(Content packet) throws ChannelException {
        if (listener != null)
            this.listener.recieve(packet);
    }
}
