/*
 * WriteChannel
 *
 * @author kpepperdine
 * Date: May 30, 2002
 * Time: 10:57:57 AM
 */

package com.sams.ant.channel;

import javax.jms.ObjectMessage;
import javax.jms.TopicPublisher;

public class WriteChannel extends Channel {

    private TopicPublisher publisher;

    /**
     * IOException, NamingException, JMSException
     */
    public void open(String host, String port, String userid, String password, String topicName) throws ChannelException {
        try {
            super.open(host, port, userid, password, topicName);
            this.publisher = super.getSession().createPublisher(super.getTopic());
        } catch (Throwable throwable) {
            throw new ChannelException(throwable);
        }

    }

    /**
     * JMSException
     */
    public void send(Content packet) throws ChannelException {
        try {
            ObjectMessage aMessage = super.getSession().createObjectMessage(packet);
            this.publisher.publish(aMessage);
        } catch (Throwable throwable) {
            throw new ChannelException(throwable);
        }
    }

}
