/*
 * ChannelTest
 *
 * @author kpepperdine
 * Date: Jun 6, 2002
 * Time: 6:00:12 PM
 */

package com.sams.ant.channel.unittest;

import com.sams.ant.channel.ChannelException;
import com.sams.ant.channel.WriteChannel;
import com.sams.ant.channel.ChannelListener;
import com.sams.ant.channel.ReadChannel;
import com.sams.ant.channel.Content;

public class ChannelTest implements ChannelListener {

    private String result;
    private WriteChannel in;
    private ReadChannel out;

    public ChannelTest(String title) {
    }

    public void setUp() {
        try {
            in = new WriteChannel();
            in.open("localhost","4001","admin","secret","ant.developer");
            out = new ReadChannel();
            out.open("localhost","4001","admin","secret","ant.developer");
            out.registerConnectionListener(this);
        } catch (ChannelException e) {
            System.out.println("Test Failed");
            System.out.println(e.getMessage());
            e.printStackTrace();
            System.exit(1);
        }
    }

    public void tearDown() {
        try {
            this.in.close();
            this.out.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    public void testPubSub() {
        try {
            String payload = "Hello world";
            TestMessage message = new TestMessage( "ChannelTest", payload);
            in.send( message);
            Thread.sleep(1000);
            if ( result != null)
                if ( payload.equals(result)) {
                    System.out.println("Test good");
                    return;
                }
        } catch (Throwable t) {
            System.out.println(t.getMessage());
            t.printStackTrace();
        }
        System.out.println("Test Failed");
    }

    public void recieve(Content content) {
        this.result = ((TestMessage)content).getPayLoad();
    }

    public static void main(String[] args) {
        ChannelTest tc = new ChannelTest("Channel Test");
        tc.setUp();
        tc.testPubSub();
        tc.tearDown();
    }
}
