/*
 * Created by IntelliJ IDEA.
 * User: kcpeppe
 * Date: Jun 16, 2002
 * Time: 7:58:01 AM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.sams.ant.chatroom;

import com.sams.ant.channel.ChannelException;
import com.sams.ant.channel.ChannelListener;
import com.sams.ant.channel.Content;
import com.sams.ant.channel.ReadChannel;
import com.sams.ant.channel.WriteChannel;

import java.util.List;
import java.util.ResourceBundle;

public class ChatClient implements ChatResources {

    private ReadChannel in;
    private String host;
    private String port;
    private String userId;
    private String password;
    private List topics;

    public ChatClient(String userId, String password) {
        this.userId = userId;
        this.password = password;
    }

    private String getUserId() {
        return this.userId;
    }

    private String getPassword() {
        return this.password;
    }

    public List getTopics() {
        return topics;
    }

    public List resolveTopicList() {

        this.topics = null;

        try {
            ResourceBundle bundle = ResourceBundle.getBundle("com.sams.ant.chatroom.chatclient");
            this.host = bundle.getString( CHATROOM_HOST);
            this.port = bundle.getString( CHATROOM_PORT);
            String topic = bundle.getString( CHATROOM_TOPIC_SERVER);
            WriteChannel out = new WriteChannel();
            out.open( host, port, userId, password, topic);
            in = new ReadChannel();
            in.open( host, port, userId, password, topic);
            ChannelListener listener = new ChannelListener() {
                public void recieve(Content content) {
                    if (userId.equals(content.getId()))
                        return;
                    topics = ((TopicMessage)content).getTopicChoices();
                }
            };
            in.registerConnectionListener(listener);
            out.send(new TopicMessage(this.getUserId()));
            out.close();
            while (this.topics == null)
                try {
                    Thread.sleep(1000);
                } catch(Exception e) {
                }
            in.close();
        } catch (ChannelException e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
            System.exit(-1);
        }

        return this.topics;
    }

    public ChatRoom enter(ChatRoomListener listener, String chatroom) throws ChatRoomException {
        ChatRoom chatRoom;

        try {
            chatRoom = new ChatRoom( chatroom);
            chatRoom.setHost(this.host);
            chatRoom.setPort(this.port);
            chatRoom.login( this.userId, this.password);
            chatRoom.registerChatRoomListener( listener);
        } catch (ChannelException ce) {
            throw new ChatRoomException(ce);
        }

        return chatRoom;
    }
}
