/*
 * Created by IntelliJ IDEA.
 * User: kcpeppe
 * Date: Jun 16, 2002
 * Time: 9:59:28 AM
 * To change template for new class use 
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.sams.ant.chatroom;

import com.sams.ant.channel.ChannelException;
import com.sams.ant.channel.ChannelListener;
import com.sams.ant.channel.Content;
import com.sams.ant.channel.ReadChannel;
import com.sams.ant.channel.WriteChannel;

public class ChatRoom implements ChannelListener {

    private ChatRoomListener listener;
    private ReadChannel in;
    private WriteChannel out;
    private String host;
    private String port;
    private String topic;
    private String id;

    public ChatRoom(String topic) {
        this.topic = topic;
    }

    public void setHost(String host) {
        this.host = host;
    }

    public void setPort(String port) {
        this.port = port;
    }

    public void login(String userId, String password) throws ChannelException {
        this.id = userId;
        out = new WriteChannel();
        out.open( this.host, this.port, userId, password, this.topic);

        in = new ReadChannel();
        in.open( this.host, this.port, userId, password, this.topic);
        in.registerConnectionListener(this);
    }

    public void send(String message) throws ChatRoomException {
        try {
            out.send( new ChatMessage(this.id, this.topic, message));
        } catch (ChannelException e) {
            throw new ChatRoomException(e.getMessage());
        }
    }

    public void recieve(Content content) {
        if (this.id.equals(content.getId()) || (listener == null))
            return;

        ChatMessage message = (ChatMessage)content;
        listener.recieve(message.getId(), message.getMessage());
    }

    public void leave() {
        in.close();
        out.close();
    }

    public void registerChatRoomListener(ChatRoomListener listener) {
        this.listener = listener;
    }
}
