/*
 * Created by IntelliJ IDEA.
 * User: kcpeppe
 * Date: Jun 15, 2002
 * Time: 7:00:51 PM
 * To change template for new class use
 * Code Style | Class Templates options (Tools | IDE Options).
 */
package com.sams.ant.chatroom;

import com.sams.ant.channel.WriteChannel;
import com.sams.ant.channel.ReadChannel;
import com.sams.ant.channel.ChannelException;
import com.sams.ant.channel.ChannelListener;
import com.sams.ant.channel.Content;

import java.util.Properties;
import java.util.ResourceBundle;
import java.util.StringTokenizer;

public class ChatServer implements ChatResources, ChannelListener {

    private WriteChannel src;
    private ReadChannel reciever;
    private TopicMessage topicMessage;

    public void ChatServer() {
    }

    private void setupTopicMessage(String topics) {
        this.topicMessage = new TopicMessage("TOPIC_SERVER");
        StringTokenizer parser = new StringTokenizer(topics,",");
        System.out.print("Starting Topics:");
        while (parser.hasMoreTokens()) {
            String topic = parser.nextToken();
            System.out.print( " " + topic);
            topicMessage.addTopic(topic);
        }
        System.out.println(".");
    }

    public void init() {
        try {
            ResourceBundle bundle = ResourceBundle.getBundle("com.sams.ant.chatroom.chatserver");
            String host = bundle.getString( CHATROOM_HOST);
            String port = bundle.getString( CHATROOM_PORT);
            String user = bundle.getString( CHAT_SERVER_USER);
            String password = bundle.getString( CHAT_SERVER_PASSWORD);
            String topic = bundle.getString( CHATROOM_TOPIC_SERVER);
            this.setupTopicMessage(bundle.getString( CHATROOMS));
            this.src = new WriteChannel();
            this.src.open( host, port, user, password, topic);
            this.reciever = new ReadChannel();
            this.reciever.open( host, port, user, password, topic);
            this.reciever.registerConnectionListener(this);
        } catch (ChannelException e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
            System.exit(-1);
        }
    }

    public void recieve(Content content) {

        if ( "TOPIC_SERVER".equals(content.getId()))
            return;
        System.out.println("Recieved message from " + content.getId() + ".");
        if (content instanceof AdminMessage)
                System.exit(0);

        try {
            this.src.send(topicMessage);
        } catch (ChannelException e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    public void run() {
        try {
            Thread.sleep(0);
        } catch (InterruptedException e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        ChatServer server = new ChatServer();
        server.init();
        server.run();
    }
}
