/*
 * Passenger.java
 *
 * Created on 5. februar 2001, 20:39
 */

package com.bekk.dbcdemo;

/**
 * This interface describes a passenger
 *
 * @author <a href="mailto:aslak.hellesoy@bekk.no">Aslak Hellesy</a>
 */
public interface Passenger {

	/**
	 * Returns the destination of the passenger
	 *
	 * @return the name of the passenger's destination
	 */
	public abstract String getDestination();

	/**
	 * Returns the weight of the hand luggage
	 *
	 * @return the weight of the hand luggage
	 * @post return >= 0
	 */
	public abstract int getHandLuggageWeight();

	/**
	 * Returns true if the ticket is paid
	 *
	 * @return true if the ticket is paid
	 */
	public abstract boolean hasTicket();
}
